/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton interface for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACT_ACCEPT = 258,
     ACT_REJECT = 259,
     ACT_TEMPFAIL = 260,
     ACT_CONTINUE = 261,
     ACT_DISCARD = 262,
     ADD = 263,
     REPLACE = 264,
     DELETE = 265,
     PROG = 266,
     IF = 267,
     FI = 268,
     ELSE = 269,
     ELIF = 270,
     ON = 271,
     HOST = 272,
     FROM = 273,
     AS = 274,
     DO = 275,
     DONE = 276,
     POLL = 277,
     MATCHES = 278,
     FNMATCHES = 279,
     MXMATCHES = 280,
     MXFNMATCHES = 281,
     WHEN = 282,
     PASS = 283,
     SET = 284,
     CATCH = 285,
     THROW = 286,
     KW_ECHO = 287,
     RETURNS = 288,
     RETURN = 289,
     FUNC = 290,
     SWITCH = 291,
     CASE = 292,
     DEFAULT = 293,
     CONST = 294,
     FOR = 295,
     LOOP = 296,
     WHILE = 297,
     BREAK = 298,
     NEXT = 299,
     STRING = 300,
     CODE = 301,
     XCODE = 302,
     SYMBOL = 303,
     VARIABLE = 304,
     IDENTIFIER = 305,
     ARG = 306,
     NUMBER = 307,
     BACKREF = 308,
     BUILTIN = 309,
     BUILTIN_PROC = 310,
     BUILTIN_P = 311,
     OR = 312,
     AND = 313,
     EQ = 314,
     NE = 315,
     LT = 316,
     LE = 317,
     GT = 318,
     GE = 319,
     NOT = 320,
     LOGAND = 321,
     LOGOR = 322,
     LOGXOR = 323,
     LOGNOT = 324,
     FUNCTION = 325,
     FUNCTION_PROC = 326,
     FUNCTION_P = 327,
     TYPE = 328,
     CONCAT = 329,
     UMINUS = 330
   };
#endif
/* Tokens.  */
#define ACT_ACCEPT 258
#define ACT_REJECT 259
#define ACT_TEMPFAIL 260
#define ACT_CONTINUE 261
#define ACT_DISCARD 262
#define ADD 263
#define REPLACE 264
#define DELETE 265
#define PROG 266
#define IF 267
#define FI 268
#define ELSE 269
#define ELIF 270
#define ON 271
#define HOST 272
#define FROM 273
#define AS 274
#define DO 275
#define DONE 276
#define POLL 277
#define MATCHES 278
#define FNMATCHES 279
#define MXMATCHES 280
#define MXFNMATCHES 281
#define WHEN 282
#define PASS 283
#define SET 284
#define CATCH 285
#define THROW 286
#define KW_ECHO 287
#define RETURNS 288
#define RETURN 289
#define FUNC 290
#define SWITCH 291
#define CASE 292
#define DEFAULT 293
#define CONST 294
#define FOR 295
#define LOOP 296
#define WHILE 297
#define BREAK 298
#define NEXT 299
#define STRING 300
#define CODE 301
#define XCODE 302
#define SYMBOL 303
#define VARIABLE 304
#define IDENTIFIER 305
#define ARG 306
#define NUMBER 307
#define BACKREF 308
#define BUILTIN 309
#define BUILTIN_PROC 310
#define BUILTIN_P 311
#define OR 312
#define AND 313
#define EQ 314
#define NE 315
#define LT 316
#define LE 317
#define GT 318
#define GE 319
#define NOT 320
#define LOGAND 321
#define LOGOR 322
#define LOGXOR 323
#define LOGNOT 324
#define FUNCTION 325
#define FUNCTION_PROC 326
#define FUNCTION_P 327
#define TYPE 328
#define CONCAT 329
#define UMINUS 330




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 278 "gram.y"
{
	struct literal *literal;
	struct stmtlist stmtlist;
	NODE *node;
	struct return_node ret;
	struct poll_data poll;
	struct locus locus;
	struct pollarg {
		int kw;
		NODE *expr;
	} pollarg;
	struct arglist {
		NODE *head;
		NODE *tail;
		size_t count;
	} arglist;
	long number;
	const struct builtin *builtin;
	struct variable *var;
	enum smtp_state state;
	struct {
		struct locus locus;
		int qualifier;
	} matchtype;
	data_type_t type;
	struct parmtype *parm;
	struct parmlist {
		struct parmtype *head, *tail;
		size_t count;
		size_t optcount;
	} parmlist;
	enum lexical_context tie_in;
	struct function *function;
	struct {
		struct valist *head, *tail;
	} valist_list;
	struct valist *valist;
	struct value value;
	struct {
		struct case_stmt *head, *tail;
	} case_list ;
	struct case_stmt *case_stmt;
	struct loop_node loop;
}
/* Line 1529 of yacc.c.  */
#line 244 "gram.h"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

extern YYSTYPE yylval;

